package com.example.kpprinter.java;

import android.Manifest;

import com.qw.soul.permission.SoulPermission;
import com.qw.soul.permission.bean.Permission;
import com.qw.soul.permission.bean.Permissions;


public class PermissionUtils {

    public interface PermissionTypeListener<T> {
        void success(T msg);

        void fail(String msg);
    }


    //位置权限
    public static void getLocations(final String title, final String msg1, final String msg2,
                                    final String msgBtn, final String msgBtn2, final PermissionTypeListener permissionTypeListener) {
        SoulPermission.getInstance().checkAndRequestPermissions(Permissions.build(Manifest.permission.ACCESS_COARSE_LOCATION,
                Manifest.permission.ACCESS_FINE_LOCATION),
                new PermissionsAdapter(title,
                        msg1,
                        msg2,
                        msgBtn,
                        msgBtn2,
                        new Runnable() {
                            @Override
                            public void run() {
                                getLocations(title,msg1,msg2,msgBtn,msgBtn2,permissionTypeListener);
                            }
                        }) {
                    @Override
                    public void onAllPermissionOk(Permission[] permissions) {
                        super.onAllPermissionOk(permissions);
                        permissionTypeListener.success("");
                    }

                    @Override
                    public void onPermissionDenied(Permission[] permissions) {
                        super.onPermissionDenied(permissions);
                        permissionTypeListener.fail("");
                    }
                }

                );

    }


}
