import 'dart:async';

import 'package:flutter/services.dart';

class Kpprinter {
  static const MethodChannel _channel =
      const MethodChannel('kpprinter');

  static const EventChannel eventChannel = 
  const EventChannel('printer_printerSearched');

  static Future searchResult(_onEvent,_onError) async{
    eventChannel.receiveBroadcastStream().listen(_onEvent,onError:_onError);
  }

  static Future<String> search(flutterPara) async {
    final String result = await _channel.invokeMethod('printer_search',flutterPara);
    return result;
  }

  static Future<String> connect(flutterPara) async {
    final String result = await _channel.invokeMethod('printer_connectAPrinter',flutterPara);
    return result;
  }

  static Future<String> disconnect(flutterPara) async {
    final String result = await _channel.invokeMethod('printer_disconnectAPrinter',flutterPara);
    return result;
  }

  static Future<String> print(flutterPara) async {
    final String result = await _channel.invokeMethod('printer_print',flutterPara);
    return result;
  }

  static Future<String> bluetoothIsOpened(flutterPara) async {
    final String result = await _channel.invokeMethod('printer_bluetoothIsOpened',flutterPara);
    return result;
  }

  static Future<String> connectAndPrint(flutterPara) async {
    final String result = await _channel.invokeMethod('printer_connectAndPrint',flutterPara);
    return result;
  }






}